/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ustasoft.pos.service;

import com.ustasoft.component.DlgLookup;
import com.ustasoft.component.GeneralFunction;
import com.ustasoft.component.Konfigurasi;
import com.ustasoft.pos.domain.Item;
import java.awt.Component;
import java.awt.Container;
import java.awt.FocusTraversalPolicy;
import java.awt.KeyboardFocusManager;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumnModel;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.type.OrientationEnum;
import pos.MainForm;
import pos.ar.FrmPenjualan;
import pos.master.list.FrmListItem;

/**
 *
 * @author ustadho
 */
public class FrmCetakBarcode extends javax.swing.JInternalFrame {
    private ReportService reportService;
    GeneralFunction fn =new GeneralFunction();
    /**
     * Creates new form FrmCetakBarcode
     */
    public FrmCetakBarcode() {
        initComponents();
        reportService = new ReportService(MainForm.conn, this);
        
         MyKeyListener kListener=new MyKeyListener();
        tblDetail.addKeyListener(kListener);
        btnNew1.addKeyListener(kListener);
        btnNew2.addKeyListener(kListener);
        
    }
    private void udfLookupItem(String cari) {
        DlgLookup d1 = new DlgLookup(JOptionPane.getFrameForComponent(this), true);

        String s = "select *  from ("
                + "select i.id::varchar as id ,coalesce(i.plu,'') as kode, i.nama_barang, coalesce(k.nama_kategori,'') as kategori, "
                + "coalesce(h.harga_jual,0) harga_jual, coalesce(i.stok,0) stok, coalesce(i.satuan,'') as satuan, coalesce(i.biaya_item,0) as biaya_item "
                + "from m_item i "
                + "left join m_item_kategori k on k.id=i.id_kategori "
                + "left join m_item_harga_jual h on h.id_item=i.id and h.id_tipe_harga_jual=1 "
                + "where coalesce(i.active, true)=true "
                //+(sItem.length()>0? "where i.id::varchar not in("+sItem+")":"")+" "
                + "order by upper(i.nama_barang)  "
                + ")x ";

        System.out.println(s);
        d1.setTitle("Lookup Stok");
        JTable tbl = d1.getTable();
        d1.setSearch("");
        d1.udfLoad(MainForm.conn, s, "(x.id||x.kode||x.nama_barang||kategori)", null);
        tbl.getColumn("id").setPreferredWidth(0);
        tbl.getColumn("id").setMinWidth(0);
        tbl.getColumn("id").setMaxWidth(0);
//        d1.setBounds(getScree, 0, 900, 500);
        d1.setSize(900, 500);
        d1.setLocationRelativeTo(null);
        d1.setVisible(true);

        if (d1.getKode().length() > 0) {
            TableColumnModel col = d1.getTable().getColumnModel();
            int iRow = tbl.getSelectedRow();
            
            ((DefaultTableModel) tblDetail.getModel()).addRow(new Object[]{
                    Integer.valueOf(tbl.getValueAt(iRow, col.getColumnIndex("id")).toString()),
                    tbl.getValueAt(iRow, col.getColumnIndex("kode")).toString(),
                    tbl.getValueAt(iRow, col.getColumnIndex("nama_barang")).toString(),
                    GeneralFunction.udfGetDouble(tbl.getValueAt(iRow, col.getColumnIndex("harga_jual")))
                });
            
            if(tblDetail.getRowCount()>0){
                tblDetail.setRowSelectionInterval(tblDetail.getRowCount()-1, tblDetail.getRowCount()-1);
                tblDetail.setModel(fn.autoResizeColWidth(tblDetail, ((DefaultTableModel)tblDetail.getModel())).getModel());
            }

        }
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        tblDetail = new javax.swing.JTable();
        btnNew1 = new javax.swing.JButton();
        btnNew2 = new javax.swing.JButton();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Cetak Barcode");
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        tblDetail.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "ID", "Kode", "Nama Barang", "Harga"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Object.class, java.lang.Object.class, java.lang.Object.class, java.lang.Double.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblDetail.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane1.setViewportView(tblDetail);

        getContentPane().add(jScrollPane1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 620, 250));

        btnNew1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/report.png"))); // NOI18N
        btnNew1.setText("Cetak Barcode");
        btnNew1.setMargin(new java.awt.Insets(2, 2, 2, 2));
        btnNew1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnNew1ActionPerformed(evt);
            }
        });
        getContentPane().add(btnNew1, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 270, 150, -1));

        btnNew2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/magnifier.png"))); // NOI18N
        btnNew2.setText("Lookup Item");
        btnNew2.setMargin(new java.awt.Insets(2, 2, 2, 2));
        btnNew2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnNew2ActionPerformed(evt);
            }
        });
        getContentPane().add(btnNew2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 270, 160, -1));

        setBounds(0, 0, 653, 340);
    }// </editor-fold>//GEN-END:initComponents

    private void btnNew1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnNew1ActionPerformed
        cetakBarcode();
    }//GEN-LAST:event_btnNew1ActionPerformed

    private void btnNew2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnNew2ActionPerformed
        udfLookupItem("");
    }//GEN-LAST:event_btnNew2ActionPerformed

    private void cetakBarcode() {
        int jumlah = GeneralFunction.udfGetInt(JOptionPane.showInputDialog(this, "Jumlah rangkap", 3));
        
        if(jumlah > 0) {
            int colID = tblDetail.getColumnModel().getColumnIndex("ID");
            String ids = "ARRAY[";
            for (int i=0; i<tblDetail.getRowCount(); i++) {
                    ids += ids.equalsIgnoreCase("ARRAY[") ? "" : ", ";
                    ids +=  String.valueOf(tblDetail.getValueAt(i, colID)) ;
            }
            ids += "]";
            System.out.println("IDS: " + ids);
            HashMap param=new HashMap();
            param.put("ids", ids);
            param.put("jumlah", jumlah);
            
            if(Konfigurasi.PRINTER_BARCODE_PREVIEW!=null && Konfigurasi.PRINTER_BARCODE_PREVIEW) {
                reportService.udfPreview(param, "barcode", OrientationEnum.PORTRAIT);
            }else{
                try {
                    reportService.printBarcode(param, "barcode", OrientationEnum.PORTRAIT, Konfigurasi.PRINTER_BARCODE);
                } catch (JRException ex) {
                    Logger.getLogger(FrmCetakBarcode.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }

    public class MyKeyListener extends KeyAdapter {

        @Override
        public void keyTyped(java.awt.event.KeyEvent evt) {

//            if(getTableSource()==null)
//                return;
            if (evt.getSource() instanceof JTextField
                    && ((JTextField) evt.getSource()).getName() != null
                    && ((JTextField) evt.getSource()).getName().equalsIgnoreCase("textEditor")) {
                fn.keyTyped(evt);

            }

        }

        public void keyPressed(KeyEvent evt) {
            Component ct = KeyboardFocusManager.getCurrentKeyboardFocusManager().getPermanentFocusOwner();
            int keyKode = evt.getKeyCode();
            switch (keyKode) {
                case KeyEvent.VK_DOWN: {
                    if (!(ct.getClass().getSimpleName().equalsIgnoreCase("JTABLE"))) {
                        if (!fn.isListVisible()) {
                            Component c = findNextFocus();
                            if (c == null) {
                                return;
                            }
                            c.requestFocus();
                        } else {
                            fn.lstRequestFocus();
                        }
                        break;
                    }
                }

                case KeyEvent.VK_UP: {
                    if (!(evt.getSource() instanceof JTable)) {
                        Component c = findPrevFocus();
                        c.requestFocus();
                    }
                    break;
                }
                case KeyEvent.VK_INSERT: {
                    udfLookupItem("");

                    break;
                }
//                case KeyEvent.VK_ESCAPE:{
//                    dispose();
//                    break;
//                }

                case KeyEvent.VK_DELETE: {
                    if (evt.getSource().equals(tblDetail) && tblDetail.getSelectedRow() >= 0) {
                        int iRow = tblDetail.getSelectedRow();
                        if (iRow < 0) {
                            return;
                        }

                        ((DefaultTableModel) tblDetail.getModel()).removeRow(iRow);
                        if (tblDetail.getRowCount() < 0) {
                            return;
                        }
                        if (tblDetail.getRowCount() > iRow) {
                            tblDetail.setRowSelectionInterval(iRow, iRow);
                        } else {
                            tblDetail.setRowSelectionInterval(0, 0);
                        }
                    }
                    break;

                }

            }
        }

//        @Override
//        public void keyReleased(KeyEvent evt){
//            if(evt.getSource().equals(txtDisc)||evt.getSource().equals(txtQty)||evt.getSource().equals(txtUnitPrice))
//                GeneralFunction.keyTyped(evt);
//        }
        public Component findNextFocus() {
            // Find focus owner
            Component c = KeyboardFocusManager.getCurrentKeyboardFocusManager().getFocusOwner();
            Container root = c == null ? null : c.getFocusCycleRootAncestor();

            if (root != null) {
                FocusTraversalPolicy policy = root.getFocusTraversalPolicy();
                Component nextFocus = policy.getComponentAfter(root, c);
                if (nextFocus == null) {
                    nextFocus = policy.getDefaultComponent(root);
                }
                return nextFocus;
            }
            return null;
        }

        public Component findPrevFocus() {
            // Find focus owner
            Component c = KeyboardFocusManager.getCurrentKeyboardFocusManager().getFocusOwner();
            Container root = c == null ? null : c.getFocusCycleRootAncestor();

            if (root != null) {
                FocusTraversalPolicy policy = root.getFocusTraversalPolicy();
                Component prevFocus = policy.getComponentBefore(root, c);
                if (prevFocus == null) {
                    prevFocus = policy.getDefaultComponent(root);
                }
                return prevFocus;
            }
            return null;
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnNew1;
    private javax.swing.JButton btnNew2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable tblDetail;
    // End of variables declaration//GEN-END:variables
}
